package model;

/**
 * Enum that represents the comments
 * @author nilc
 *
 */
public enum Comment {
	
	NO_COMMENTS("Sem comentários"), 

	COMPLEX_PREDICATE("É predicado complexo"),

	ANNOTATION_ERROR("Não é um verbo, erro de anotação"),

	AUXILIAR_VERB("Verbo auxiliar"),

	OTHER("Outros");
	
	private String description;	
	
	Comment( String description ){
		this.description = description;
	}

	@Override
	public String toString() {
		return this.description;
	}

	/**
	 * 
	 * @param contentComment
	 * @return
	 */
	public static Comment getNameTag(String contentComment) {
		if(contentComment.equals(NO_COMMENTS.name())) return NO_COMMENTS;
		
		if(contentComment.equals(AUXILIAR_VERB.name())) return AUXILIAR_VERB;
		
		if(contentComment.equals(COMPLEX_PREDICATE.name())) return COMPLEX_PREDICATE;
		
		if(contentComment.equals(ANNOTATION_ERROR.name())) return ANNOTATION_ERROR;
		
		if(contentComment.equals(OTHER.name())) return OTHER;
			
		return null;
	}

	public static Comment getComment(String content) {
		if(content.equals("Sem comentários")) return NO_COMMENTS;
		
		if(content.equals("É predicado complexo")) return COMPLEX_PREDICATE;
		
		if(content.equals("Não é um verbo, erro de anotação")) return ANNOTATION_ERROR;
		
		if(content.equals("Verbo auxiliar")) return AUXILIAR_VERB;
		
		if(content.equals("Outros")) return OTHER;
		
		return null;
	}

}
