package model.ontology;

import java.util.ArrayList;
import java.util.List;


public class Node {

	String name; // nome do synset
	int id; // hashCode
	int nSelect;
	int countSub; // conta se sua subarvore contem algum no selecionado
    List<Relation> adj;
          
    public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getnSelect() {
		return nSelect;
	}

	public void setnSelect(int nSelect) {
		this.nSelect = nSelect;
	}

	public List<Relation> getAdj() {
		return adj;
	}

	public void setAdj(List<Relation> adj) {
		this.adj = adj;
	}

	public Node(String name, int id, int nSelect) {
        this.name = name;
        this.id = id;
        this.nSelect = nSelect;
        this.adj = new ArrayList<Relation>();
        this.countSub = 0;
    }
	
	public Node(String name, int id, int nSelect, int countSub) {
        this.name = name;
        this.id = id;
        this.nSelect = nSelect;
        this.adj = new ArrayList<Relation>();
        this.countSub = countSub;
    }
	
	public Node(String name, int id) {
        this.name = name;
        this.id = id;
        this.nSelect = 0;
        this.adj = new ArrayList<Relation>();
        this.countSub = 0;
    }

    public void addAdjacent (Relation relation){
    	for( Relation ar: this.adj ) {
    	   if( ar.equals(relation) )
    		   return;
    	}
    	this.adj.add(relation);
    }   
    
    public void addEdge( Relation edge) {
    	int i=0;
    	for( Relation ar: this.adj ) {
    	   if( ar.equals(edge) ) {
    		   break;
    	   }
    		i++;
    	}
    	if( this.adj.size() == i)
    	  	this.adj.add(edge);
    	else
    		this.adj.set(i, edge);
    }
    
    public int getCountSub() {
		return countSub;
	}

	public void setCountSub(int countSub) {
		this.countSub = countSub;
	}

	public boolean equals(Node aux){
    	if(name.equals(aux.getName()) && id == aux.getId())
    		return true;
    	return false;
    }

	public Relation findEdge(Node destino) {
	for (Relation edge : this.adj) {
		if( edge.getDestination().equals( destino ) )
			return edge;
	}		
	return null;
	}
	
	@Override
	public String toString() {
		return getName() + " id: " + getId() + " nSelect: " + getnSelect() + " subCount: " + getCountSub();
	}

}
